/*---------------------------------------------------------------------------
 * �2005 NORSYS
 * main author : jeff
 *
 * This software is a computer program whose purpose is to provide
abstraction
 * for accessing directory data sources within java applications.
 *
 * This software is governed by the CeCILL  license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems
and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 * Created on 31 oct. 2005
 *
--------------------------------------------------------------------------*/
package speculoos.jndi.mappers;

import java.util.Map;

import javax.naming.NamingException;

import speculoos.core.MapperException;
import speculoos.jndi.DeleteMapper;

/**
 * Implementation of delete mapper.
 * <p>
 * The output map of a delete mapper may be null.
 * </p>
 * @author jeff
 * @version $Id$
 */
public class DeleteMapperImpl extends JNDIMapper implements DeleteMapper {
	
	public DeleteMapperImpl() {
		super("delete");
	}

	public DeleteMapperImpl(String value) {
		super(value);
	}

	/*
	 *  (non-Javadoc)
	 * @see speculoos.jndi.DeleteMapper#delete(java.util.Map, java.util.Map)
	 */
	public Object delete(Map input, Map env) throws MapperException {
		return map(input,env);
	}
	
	/*
	 *  (non-Javadoc)
	 * @see speculoos.jndi.mappers.JNDIMapper#doMap(java.lang.Object, java.util.Map)
	 */
	public Object doMap(Object input, Map param) throws MapperException {

		try {
			if(log.isDebugEnabled())
				log.debug("["+getName()+"] deleting "+_root);
			directory.destroySubcontext(_root);
			if(log.isDebugEnabled())
				log.debug("["+getName()+"] done");
			return input;
		} catch (NamingException e) {
			throw new MapperException("Exception in JNDI deleting "
					+ e.getLocalizedMessage(), e);
		}	}
	
	
}